# URI:Query:WWWForm

NOTE: This module is a draft. No syntax checkking is performed on the query part, nor are invalid escape sequences detected. I don't know if this query class should be applied to all HTTP URIs.

### Import List

        ADT:ArrayList
        ADT:Dictionary
        ADT:StringBuffer
        Exception
        Exception
        Object
        Object
        TextRider
        URI

Class List
Query |

Class Summary: Query [Detail]

      +---URI.Query
           |
           +--URI:Query:WWWForm.Query

Field Summary
dict-: Dictionary STRING ArrayList STRING Maps a name to a list of its values.
names-: ArrayList STRING
values-: ArrayList STRING
Constructor Summary
Init(Query)
New(): Query
Method Summary
Add(STRING, STRING)
Append(StringBuffer) Appends the textual representation of the query component query to the string sb.
Clone(): Query Creates a deep copy of the queryority component referenced by query.
Copy(Query) Copies contents of source query to target dest.
ParseQuery(CharsLatin1, Offset) Parses the query component str of an hierarchical URI.
ParseString(ARRAY OF CHAR, LONGINT, LONGINT)
WriteXML(Writer) Writes an XML fragment describing the query component to the writer w.
Inherited Methods
From URI.Query: Append, Clone, Copy, ParseQuery, WriteXML

Class Detail: Query

Field Detail

### dict

    FIELD dict-: DictionarySTRINGArrayListSTRING

> Maps a name to a list of its values.

### names

    FIELD names-: ArrayListSTRING

### values

    FIELD values-: ArrayListSTRING

Constructor Detail

### Init

    PROCEDURE Init(query: Query)

### New

    PROCEDURE New(): Query

Method Detail

### Add

    PROCEDURE (query: Query) Add(name: STRING;
                  value: STRING)

### Append

    PROCEDURE (query: Query) Append(sb: StringBuffer)

> Appends the textual representation of the query component query to the string sb.

> [Description inherited from Append]

> Redefines: Append

### Clone

    PROCEDURE (query: Query) Clone(): Query

> Creates a deep copy of the queryority component referenced by query.

> [Description inherited from Clone]

> Redefines: Clone

### Copy

    PROCEDURE (query: Query) Copy(dest: Query)

> Copies contents of source query to target dest.

> Pre-condition: The dynamic type of dest is an extension of the dynamic type of query.

> [Description inherited from Copy]

> Redefines: Copy

### ParseQuery

    PROCEDURE (query: Query) ParseQuery(str: CharsLatin1;
                         offset: Offset)
      RAISES ParseError;

> Parses the query component str of an hierarchical URI. On success, the data is stored in the query object query and the result is NIL. In case of error, a message object is returned and query is not modified. A character position in an error message refers to an index in str, incremented by the value of offset.

> [Description inherited from ParseQuery]

> Redefines: ParseQuery

### ParseString

    PROCEDURE (query: Query) ParseString(b: ARRAY OF CHAR;
                          pos: LONGINT;
                          endpos: LONGINT)

### WriteXML

    PROCEDURE (query: Query) WriteXML(w: Writer)

> Writes an XML fragment describing the query component to the writer w.

> [Description inherited from WriteXML]

> Redefines: WriteXML